# Set Custom Uniform

## Overview

![The Set Custom Uniform Node.](/files/7N2qmooMoJR9o3W1GdaU)

The **Set Custom Uniform Node** allows the user to set values for a **Custom Material's** `Uniforms` **Attributes**, which are found specifically in the [**Custom Shading Model**](/incari-studio/2023.1/modules/material-editor/customshadingmodel.md).

[**Scope**](/incari-studio/2023.1/toolbox/overview.md#scopes): **Scene**, **Function**, **Prefab**

## Attributes

![The Set Custom Uniform Node Attributes](/files/8JsEd7rgOUN1RtRqAKby)

| Attribute        | Type           | Description                                                                                           |
| ---------------- | -------------- | ----------------------------------------------------------------------------------------------------- |
| `CustomUniforms` | **MaterialID** | The **Custom Material** whose `Uniforms` will be set, if one is not attached in the **Input Socket**. |

## Inputs

| Input             | Type           | Description                                                                                                                |
| ----------------- | -------------- | -------------------------------------------------------------------------------------------------------------------------- |
| *Pulse Input* (►) | **Pulse**      | A standard **Input Pulse**, to trigger the execution of the **Node**.                                                      |
| `Material ID`     | **MaterialID** | The **Custom Material** whose `Uniforms` will be set.                                                                      |
| `iChannelx`       | **TextureID**  | A *texture map* to set as a `Uniform`. The *x* refers to the identifying integer in the name, which can be 0, 1, 2, and 3. |
| `iVec4x`          | **Vector4**    | A **Vector4** to set as a `Uniform`. The *x* refers to the identifying integer in the name, which can be 0, 1, 2, and 3.   |
| `iFloatx`         | **Float**      | A **Float** to set as a `Uniform`. The *x* refers to the identifying integer in the name, which can be 0, 1, 2, and 3.     |
| `iIntx`           | **Int**        | An **Int** to set as a `Uniform`. The *x* refers to the identifying integer in the name, which can be 0, 1, 2, and 3.      |
| `iBoolx`          | **Bool**       | A **Bool** to set as a `Uniform`. The *x* refers to the identifying integer in the name, which can be 0, 1, 2, and 3.      |

## Outputs

| Output             | Type      | Description                                                                                                                            |
| ------------------ | --------- | -------------------------------------------------------------------------------------------------------------------------------------- |
| *Pulse Output* (►) | **Pulse** | A standard **Output Pulse**, to move onto the next **Node** along the **Logic Branch**, once this **Node** has finished its execution. |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.incari.com/incari-studio/2023.1/toolbox/incari/material/setcustomuniforms.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
